﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GaugeDragDrop
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Border bdr;
        bool isMouseCaptured = false;
        public MainWindow()
        {
            InitializeComponent();

            linearGauge.MouseLeftButtonDown += (s1, e1) =>
            {
                bdr = e1.OriginalSource as Border;
                isMouseCaptured = true;
                bdr.Cursor = Cursors.Hand;
                bdr.CaptureMouse();
            };
            linearGauge.MouseMove += (s3, e3) =>
            {
                if (isMouseCaptured)
                {
                    var pathlength = linearGauge.ActualWidth * linearGauge.XAxisLength;
                    var startposition = linearGauge.ActualWidth * linearGauge.XAxisLocation;
                    var offset = Convert.ToDouble((linearGauge.Maximum - linearGauge.Minimum) / pathlength);

                    var pixelvalue = Convert.ToDouble(offset * startposition);

                    linearGauge.Value = Convert.ToDouble((e3.GetPosition(linearGauge).X * offset) - pixelvalue + linearGauge.Minimum);
                    if (linearGauge.Value < linearGauge.Minimum)
                        linearGauge.Value = linearGauge.Minimum;
                    else if (linearGauge.Value > linearGauge.Maximum)
                        linearGauge.Value = linearGauge.Maximum;
                }
            };
            linearGauge.MouseLeftButtonUp += (s2, e2) =>
            {
                if (bdr != null)
                {
                    bdr.ReleaseMouseCapture();
                    bdr.Cursor = Cursors.Arrow;
                    isMouseCaptured = false;
                }
            };
        }
    }
}
